module StoreCurrentUser
  module ControllerMethods
    module ClassMethods
      def stores_current_user
        if respond_to? :before_filter # Rails 3
          before_filter :set_current_user
        elsif respond_to? :before_action # Rails >= 4
          before_action :set_current_user
        end
      end
    end

    module InstanceMethods
      private

      def set_current_user
        User.current = current_user if defined? User
      end
    end
  end
end